Description

This guide a is to show how to build MariaDB with WSREP and Galera for a Multi-Master SQL database cluster. It is assumed that a
FreeNAS jail has been setup as per Issue #329 and root access has been obtained.

e Update the ports tree:

portsnap fetch extract

e Once that is done, build mariadb55-server from the ports tree, the uninstall mariadb55-server. This is to resolve the source
dependencies for recompiling the MariaDB server later on with wsrep.

cd /usr/ports/databases/mariadb55-server
make install clean
make deinstall clean

e And now resolve a few dependencies before compiling the new MariaDB server:

pkg install bzr bison boost-all scons libcheck cmake bash rsync gcc48

Download and compile MariaDB with wsrep

e Download the latest Galera patched MariaDB from launchpad

cd /usr/src
bzr branch lp:~maria-captains/maria/maria-5.5-galera maria-5.5-galera

e Compile MariaDB with wsrep:

cd maria-5.5-galera

cmake . -DBUILD_CONFIG=mysql_release -DWITH_WSREP=ON -DWITH_INNODB_DISALLOW_WRITES=1
make

make install

cd ..

Download and compile Galera

e |nstall Galera from the ports tree (recommended)

cd /usr/ports/databases/galera
make install clean
http://project.altservice.com/issues/329

Or install from the developers tree:
e Remove any existing galera packages:
cd /usr/ports/databases/galera
make deinstall clean
pkg remove galera

cd /usr/src
bash

e Modify the build environment

export CC=gcc48
export CXX=c++48
export CPP=cpp48

e Download galera source

bzr branch lp:galera/2.x galera-2.x
cd galera-2.x
bash ./scripts/build.sh

e Copy the modules:

cp garb/garbd /usr/local/mysql/bin/
cp libgalera_smm.so /usr/local/lib/
Configure mysql

e Copy mysql config sample:

cp /usr/local/mysqgl/support-files/my-small.cnf /usr/local/etc/my.cnf

o Edit the mysql config file:

vi /usr/local/etc/my.cnf

o And add or modify the following:

[mysqgld]

binlog_format=ROW
default-storage—-engine=innodb
innodb_autoinc_lock_mode=2
bind-address=0.0.0.0

# Galera Provider Configuration
wsrep_provider=/usr/local/lib/libgalera_smm.so

#wsrep_provider_options="gcache.size=32G"

# Galera Cluster Configuration
wsrep_cluster_name="example_cluster"

# Initialize the cluster; switch after --wsrep-new-cluster has been run and other nodes ha
ve Jjoined.
wsrep_cluster_address="gcomm://

# Set cluster node addresses (hostnames work too)
#wsrep_cluster_address="gcomm://192.168.0.1,192.168.0.2,192.168.0.3"

# Galera Synchronization Congifuration
wsrep_sst_method=rsync
#wsrep_sst_auth=user:pass

# Galera Node Configuration
wsrep_node_address="192.168.0.1"
wsrep_node_name="dbl.example.com"

Setup the boot scripts

e Copy the boot mariadb boot script

cp /usr/local/mysqgl/support—-files/mysqgl.server /usr/local/etc/rc.d/mysqgl.server.sh

* The boot script also needs to be edited, like the following example:

vi /usr/local/etc/rc.d/mysqgl.server.sh

o And modify the two configuration parameters:

basedir=/usr/local/mysql
datadir=/usr/local/mysqgl/data

e |nitialize and secure the MariaDB database

cd /usr/local/mysqgl
/usr/local/mysql/scripts/mysqgl_install_db
chown -R mysql:mysqgl data/

® Bootstrap the new Galera cluster

service mysqgl.server.sh bootstrap

1. The alternate way to bootstrap the cluster is like so:

/usr/local/mysql/bin/mysgld --user=mysql —--wsrep-new-cluster

* Now in a second terminal connection run the mysql_secure_installation script to do some post-installation hardening:

/usr/local/mysqgl/bin/mysqgl_secure_installation

* By this point MariaDB should be able to be controlled by the service command:

service mysqgl.server.sh stop
service mysqgl.server.sh start
e Check the wsrep status

mysgl —-uroot -p —e "SHOW STATUS LIKE 'wsrep_%';"

Resources

https://mariadb.com/kb/en/getting-the-mariadb-source-code/
https://mariadb.com/kb/en/generic-build-instructions/
https://mariadb.com/kb/en/getting-started-with-mariadb-galera-cluster/
https://code.launchpad.net/maria
http://www.fromdual.ch/building-galera-replication-from-scratch
https://mariadb.com/kb/en/starting-and-stopping-mariadb-automatically/
http://planet.mysql.com/entry/?id=30931

e http://galeracluster.com/documentation-webpages/compiling.html
http://www.fromdual.com/building-galera-replication-from-scratch

History

#1 - 04/28/2014 11:07 PM - Daniel Curtis
- Description updated

- % Done changed from 30 to 70

#2 - 04/28/2014 11:10 PM - Daniel Curtis
- Description updated

- % Done changed from 70 to 80

#3 - 04/28/2014 11:12 PM - Daniel Curtis

- Description updated

#4 - 04/29/2014 07:59 AM - Daniel Curtis

- Description updated

#5 - 04/29/2014 08:05 AM - Daniel Curtis

- Description updated

#6 - 04/29/2014 03:51 PM - Daniel Curtis

- Description updated

#7 - 12/10/2014 02:35 PM - Daniel Curtis
- Project changed from 82 to FreeBSD Administration

- Description updated

#8 - 12/10/2014 04:12 PM - Daniel Curtis

- Description updated

#9 - 12/11/2014 11:37 AM - Daniel Curtis

- Description updated

#10 - 12/13/2014 06:22 PM - Daniel Curtis
- Description updated

- % Done changed from 80 to 90

#11 - 12/13/2014 08:02 PM - Daniel Curtis
- Description updated
- Status changed from In Progress to Resolved

- % Done changed from 90 to 100
https://mariadb.com/kb/en/getting-the-mariadb-source-code/
https://mariadb.com/kb/en/generic-build-instructions/
https://mariadb.com/kb/en/getting-started-with-mariadb-galera-cluster/
https://code.launchpad.net/maria
http://www.fromdual.ch/building-galera-replication-from-scratch
https://mariadb.com/kb/en/starting-and-stopping-mariadb-automatically/
http://planet.mysql.com/entry/?id=30931
http://galeracluster.com/documentation-webpages/compiling.html
http://www.fromdual.com/building-galera-replication-from-scratch

#12 - 12/15/2014 10:00 AM - Daniel Curtis
- Description updated

#13 - 12/15/2014 01:23 PM - Daniel Curtis
- Description updated

#14 - 12/26/2014 07:20 PM - Daniel Curtis

- Status changed from Resolved to Closed

#15 - 02/14/2015 10:35 AM - Daniel Curtis

- Target version set to 5

#16 - 02/14/2015 11:25 AM - Daniel Curtis

- Category set to Database Server

#17 - 02/14/2015 11:25 AM - Daniel Curtis

- Target version changed from 5 to FreeNAS 9.x
